Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/readsulfate.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/readsulfate.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/readsulfate.F	(revision 634)
@@ -2,6 +2,6 @@
 ! $Header$
 !
-      SUBROUTINE readsulfate (r_day, first, sulfate)
-      
+      SUBROUTINE readsulfate (r_day, first, sulfate_p)
+      USE dimphy, klon=>klon2,klon2=>klon
       IMPLICIT none
       
@@ -34,10 +34,10 @@
 #include "chem.h"      
 #include "dimensions.h"      
-#include "dimphy.h"      
+cym#include "dimphy.h"      
 #include "temps.h"      
 c 
 c Input:
 c ------
-      REAL*8  r_day                   ! Day of integration
+      REAL  r_day                   ! Day of integration
       LOGICAL first                 ! First timestep 
                                     ! (and therefore initialization necessary)
@@ -45,7 +45,10 @@
 c Output:      
 c -------     
-      REAL*8  sulfate (klon, klev)  ! Mass of sulfate (monthly mean data, 
-                                  !  from file) [ug SO4/m3]
-c      
+c$$$      REAL*8  sulfate_p(klon2,klev)
+c$$$      REAL*8  sulfate (klon, klev)  ! Mass of sulfate (monthly mean data, 
+c$$$                                  !  from file) [ug SO4/m3]
+      REAL  sulfate_p(klon2,klev)
+      REAL  sulfate (klon, klev)  ! Mass of sulfate (monthly mean data, 
+                                  !  from file) [ug SO4/m3]c      
 c Local Variables:
 c ----------------      
@@ -62,13 +65,28 @@
       REAL*8 so4_2(iim, jjm+1, klev, 12)   ! The sulfate distributions
       
-      REAL*8 so4(klon, klev, 12)  ! SO4 in right dimension
-      SAVE so4
-      REAL*8 so4_out(klon, klev)
-      SAVE so4_out
+cym      REAL*8 so4(klon, klev, 12)  ! SO4 in right dimension
+cym      SAVE so4
+cym      REAL*8 so4_out(klon, klev)
+cym      SAVE so4_out
+
+      REAL*8,allocatable,save :: so4(:, :, :)  ! SO4 in right dimension
+      REAL*8,allocatable,save :: so4_out(:, :)
       
       LOGICAL lnewday 
       LOGICAL lonlyone
       PARAMETER (lonlyone=.FALSE.)
-
+      logical,save :: first2=.true.
+
+      if (first2) then
+     
+        allocate( so4(klon, klev, 12) )
+        allocate( so4_out(klon, klev))
+          
+        first2=.false.
+	
+      endif
+
+      if (phy_rank==0) then
+            
       iday = INT(r_day) 
       
@@ -249,5 +267,9 @@
 
       ENDIF ! Did I have to do anything (was it a new day?)
-      
+
+      endif   ! phy_rank==0
+      
+      call ScatterField(sulfate,sulfate_p,klev)
+            
       RETURN
       END
@@ -261,6 +283,6 @@
 c-----------------------------------------------------------------------------
       
-      SUBROUTINE readsulfate_preind (r_day, first, pi_sulfate)
-      
+      SUBROUTINE readsulfate_preind (r_day, first, pi_sulfate_p)
+      USE dimphy, klon=>klon2,klon2=>klon
       IMPLICIT none
       
@@ -289,10 +311,10 @@
 #include "chem.h"      
 #include "dimensions.h"      
-#include "dimphy.h"      
+cym#include "dimphy.h"      
 #include "temps.h"      
 c 
 c Input:
 c ------
-      REAL*8  r_day                   ! Day of integration
+      REAL r_day                   ! Day of integration
       LOGICAL first                 ! First timestep 
                                     ! (and therefore initialization necessary)
@@ -300,6 +322,7 @@
 c Output:      
 c -------     
-      REAL*8  pi_sulfate (klon, klev)  ! Number conc. sulfate (monthly mean data, 
-                                  !  from file)
+      REAL pi_sulfate_p (klon2, klev)  
+      REAL pi_sulfate (klon, klev)  ! Number conc. sulfate 
+                                       ! (monthly mean data, 
 c      
 c Local Variables:
@@ -311,13 +334,29 @@
       INTEGER im, day1, day2, im2, ismaller
       REAL*8 pi_so4_1(iim, jjm+1, klev, 12)
-      
-      REAL*8 pi_so4(klon, klev, 12)  ! SO4 in right dimension
-      SAVE pi_so4
-      REAL*8 pi_so4_out(klon, klev)
-      SAVE pi_so4_out
+
+cym      REAL*8 pi_so4(klon, klev, 12)  ! SO4 in right dimension
+cym      SAVE pi_so4
+cym      REAL*8 pi_so4_out(klon, klev)
+cym      SAVE pi_so4_out
+
+      REAL*8,allocatable,save :: pi_so4(:, :, :)  ! SO4 in right dimension
+      REAL*8,allocatable,save :: pi_so4_out(:, :)
+            
       
       CHARACTER*4 cyear
       LOGICAL lnewday
-
+      logical,save :: first2=.true.
+
+      if (first2) then
+     
+        allocate( pi_so4(klon, klev, 12) )
+        allocate( pi_so4_out(klon, klev))
+          
+        first2=.false.
+	
+      endif
+
+      if (phy_rank==0) then
+    
       
 
@@ -463,4 +502,10 @@
 
       ENDIF ! Was this the beginning of a new day?
+
+      endif   ! phy_rank==0
+      
+      call ScatterField(pi_sulfate,pi_sulfate_p,klev)
+
+
       RETURN
       END
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/soil.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/soil.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/soil.F	(revision 634)
@@ -4,4 +4,5 @@
       SUBROUTINE soil(ptimestep, indice, knon, snow, ptsrf, ptsoil,
      s          pcapcal, pfluxgrd)
+      use dimphy
       IMPLICIT NONE
 
@@ -49,7 +50,7 @@
 c   -------------
 
-#include "dimensions.h"
+cym#include "dimensions.h"
 #include "YOMCST.h"
-#include "dimphy.h"
+cym#include "dimphy.h"
 #include "dimsoil.h"
 #include "indicesol.h"
@@ -78,7 +79,9 @@
       REAL dz1(nsoilmx),dz2(nsoilmx)
 c$$$          REAL zc(klon,nsoilmx),zd(klon,nsoilmx)
-      REAL zc(klon,nsoilmx,nbsrf),zd(klon,nsoilmx,nbsrf)
+cym      REAL zc(klon,nsoilmx,nbsrf),zd(klon,nsoilmx,nbsrf)
+      REAL,ALLOCATABLE,SAVE ::  zc(:,:,:),zd(:,:,:)
       REAL lambda
-      SAVE dz1,dz2,zc,zd,lambda
+cym      SAVE dz1,dz2,zc,zd,lambda
+      SAVE dz1,dz2,lambda
       LOGICAL firstcall, firstsurf(nbsrf)
       SAVE firstcall, firstsurf
@@ -90,5 +93,5 @@
 
       DATA isol,isno,iice/2000.,2000.,2000./
-
+      LOGICAL,SAVE :: First=.true.
 c-----------------------------------------------------------------------
 c   Depthts:
@@ -103,4 +106,9 @@
 c   on corrige si on a un point de terre avec ou sans glace
 c
+      IF (first) THEN
+        allocate(zc(klon,nsoilmx,nbsrf),zd(klon,nsoilmx,nbsrf))
+	first=.false.
+      ENDIF
+      
       IF (indice.EQ.is_sic) THEN
          DO ig = 1, knon
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/thermcell.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/thermcell.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/thermcell.F	(revision 634)
@@ -6,5 +6,5 @@
 c    s                  ,pu_therm,pv_therm
      s                  ,r_aspect,l_mix,w2di,tho)
-
+      USE dimphy
       IMPLICIT NONE
 
@@ -33,6 +33,6 @@
 c   -------------
 
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 
@@ -85,6 +85,6 @@
       real fracc(klon,klev+1)
       real zf,zf2
-      real thetath2(klon,klev),wth2(klon,klev)
-      common/comtherm/thetath2,wth2
+      real,allocatable,save :: thetath2(:,:),wth2(:,:)
+cym      common/comtherm/thetath2,wth2
 
       real count_time
@@ -132,5 +132,5 @@
       save ncorrec
       data ncorrec/0/
-      
+      logical,save :: firstCall=.true.
 c
 c-----------------------------------------------------------------------
@@ -138,4 +138,11 @@
 c   ---------------
 c
+      if (firstcall) then
+        allocate(thetath2(klon,klev),wth2(klon,klev))
+	thetath2(:,:)=0.
+	wth2(:,:)=0.
+	firstcall=.false.
+      endif
+      
        sorties=.true.
       IF(ngrid.NE.klon) THEN
@@ -979,4 +986,5 @@
       subroutine dqthermcell(ngrid,nlay,ptimestep,fm,entr,masse
      .    ,q,dq,qa)
+      use dimphy
       implicit none
 
@@ -989,6 +997,6 @@
 c=======================================================================
 
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 
       integer ngrid,nlay
@@ -1053,4 +1061,5 @@
      .    ,fraca,larga
      .    ,u,v,du,dv,ua,va)
+       use dimphy
       implicit none
 
@@ -1063,6 +1072,6 @@
 c=======================================================================
 
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 
       integer ngrid,nlay
@@ -1166,4 +1175,5 @@
       subroutine dqthermcell2(ngrid,nlay,ptimestep,fm,entr,masse,frac
      .    ,q,dq,qa)
+      use dimphy
       implicit none
 
@@ -1176,6 +1186,6 @@
 c=======================================================================
 
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 
       integer ngrid,nlay
@@ -1246,4 +1256,5 @@
      .    ,fraca,larga
      .    ,u,v,du,dv,ua,va)
+      use dimphy
       implicit none
 
@@ -1256,6 +1267,6 @@
 c=======================================================================
 
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 
       integer ngrid,nlay
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/transp.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/transp.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/transp.F	(revision 634)
@@ -5,5 +5,6 @@
      e                   t, q, u, v, geom,
      s                   vtran_e, vtran_q, utran_e, utran_q)
-c
+c 
+       USE dimphy
       IMPLICIT none
 c======================================================================
@@ -13,6 +14,6 @@
 c======================================================================
 c
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 c
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/ustarhb.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/ustarhb.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/ustarhb.F	(revision 634)
@@ -3,4 +3,5 @@
 !
       SUBROUTINE ustarhb(knon,u,v,cd_m, ustar)
+      use dimphy
       IMPLICIT none
 c======================================================================
@@ -17,6 +18,6 @@
 c model. J. of Climate, vol. 6, 1825-1842.
 c======================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 c
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/vdif_kcay.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/vdif_kcay.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/vdif_kcay.F	(revision 634)
@@ -5,8 +5,9 @@
      s   ,zlev,zlay,u,v,teta,cd,q2,q2diag,km,kn,ustar
      s   ,l_mix)
+      use dimphy
       IMPLICIT NONE
 c.......................................................................
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 c.......................................................................
 c
@@ -195,6 +196,6 @@
       PARAMETER (q2min=1.e-5)
       PARAMETER (q2max=1.E+2)
-      PARAMETER (nlay=klev)
-      PARAMETER (nlev=klev+1)
+cym      PARAMETER (nlay=klev)
+cym      PARAMETER (nlev=klev+1)
 c
       PARAMETER (
@@ -226,5 +227,7 @@
 c
 c   Initialisation de q2
-
+      nlay=klev
+      nlev=klev+1
+       
       call yamada(ngrid,dt,g,rconst,plev,temp
      s   ,zlev,zlay,u,v,teta,cd,q2diag,km,kn,ustar
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/wrgradsfi.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/wrgradsfi.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/wrgradsfi.F	(revision 634)
@@ -2,5 +2,6 @@
 ! $Header$
 !
-      subroutine wrgradsfi(if,nl,fieldfi,name,titlevar)
+      subroutine wrgradsfi(if,nl,fieldfi_p,name,titlevar)
+      use dimphy
       implicit none
 
@@ -8,9 +9,10 @@
 
 #include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimphy.h"
 
 c   arguments
       integer if,nl
-      real fieldfi(klon,nl)
+      real fieldfi_p(klon,nl)
+      real fieldfi(klon2,nl)
       real fielddyn((iim+1)*(jjm+1),llm)
       character*10 name
@@ -24,9 +26,13 @@
 
 c     print*,'Transformation pour ',name
-      call gr_fi_dyn(nl,klon,iim+1,jjm+1,fieldfi,fielddyn)
+      call GatherField(fieldfi_p,fieldfi,nl)
+      
+      if (phy_rank==0) then
+        call gr_fi_dyn(nl,klon,iim+1,jjm+1,fieldfi,fielddyn)
 c     print*,'Transformation OK '
-      call wrgrads(if,nl,fielddyn,name,titlevar)
+        call wrgrads(if,nl,fielddyn,name,titlevar)
 c     print*,'Ecriture ok'
-
+      endif
+      
       return
       end
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/write_histISCCP.h
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/write_histISCCP.h	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/write_histISCCP.h	(revision 634)
@@ -11,16 +11,15 @@
         DO k=1,kmaxm1
          zx_tmp_fi3d(1:klon, 1:lmaxm1)=fq_isccp(1:klon,k,1:lmaxm1)*100.
-         CALL gr_fi_ecrit(lmaxm1,klon,iim,jjmp1,zx_tmp_fi3d,
-     .                    zx_tmp_3d)
+cym         CALL gr_fi_ecrit(lmaxm1,klon,iim,jjmp1,zx_tmp_fi3d,
+cym     .                    zx_tmp_3d)
 c
 cIM: champ 3d : (lon,lat,pres) pour un tau fixe
 c
-         CALL histwrite(nid_isccp,"cldISCCP_"//taulev(k),itau_w,
-     .                  zx_tmp_3d,iim*jjmp1*lmaxm1,ndex3d)
+         CALL histwrite_phy(nid_isccp,"cldISCCP_"//taulev(k),itau_w,
+     .                  zx_tmp_fi3d)
         ENDDO !k
 c
-        CALL gr_fi_ecrit(1, klon,iim,jjmp1,nbsunlit(1,:),zx_tmp_2d)
-        CALL histwrite(nid_isccp,"nsunlit",itau_w,
-     .                 zx_tmp_2d,iim*jjmp1,ndex2d)
+cym        CALL gr_fi_ecrit(1, klon,iim,jjmp1,nbsunlit(1,:),zx_tmp_2d)
+        CALL histwrite_phy(nid_isccp,"nsunlit",itau_w,nbsunlit(1,:))
 c
        if (ok_sync) then
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/write_histREGDYN.h
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/write_histREGDYN.h	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/write_histREGDYN.h	(revision 634)
@@ -3,4 +3,6 @@
 !
       if (ok_regdyn) then
+      
+      if (monocpu) then
 
 c   Comprendre comment marche el i=nint(zout/zsto)
@@ -66,4 +68,6 @@
         call histsync(nid_regdyn)
       endif
+      
+      endif ! monocpu
 
       endif
